<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Mario Haim (mario.haim@mediatool.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Module 'Search logging' for the 'mh_ajaxsearch' extension.
 *
 * @author	Mario Haim <mario.haim@mediatool.at>
 */



	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);
require ('conf.php');
require ($BACK_PATH.'init.php');
require ($BACK_PATH.'template.php');
$LANG->includeLLFile("EXT:mh_ajaxsearch/mod1/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

class tx_mhajaxsearch_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $pathToImg;

	/**
	 *
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		//for all the edit, delete and so on images
		$this->pathToImg = '../../../../typo3/gfx/';

		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("menu_all"),
				"2" => $LANG->getLL("menu_loggedin"),
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;

		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{

				// Draw the header.
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST" enctype="multipart/form-data" name="tx_mhajaxsearch_form">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
				<script type="text/javascript" src="./jsdraw/wz_jsgraphics.js"></script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			// Render content:
			$this->moduleContent();

			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}

			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{
		$this->content .= $this->doc->endPage();
		echo $this->content;
	}

	/**
	 * Generates the module content
	 */
	function moduleContent() {

		global $LANG, $BACK_PATH;
		$_POST = array_merge($_GET, $_POST);
		
		if((string)$this->MOD_SETTINGS["function"] == 1) {
			$title = $LANG->getLL("menu_all");
			$addWhere = '';
		} else {
			$title = $LANG->getLL("menu_loggedin");
			$addWhere = 'tx_mhajaxsearch_query.nUseId != 0';
		}
		
		$content = $this->lastResults($addWhere);
		$content .= '<br />';
		$content .= $this->TopResults($addWhere);

		$this->content .= $this->doc->section($title, $content, 0, 1);
	}
	
	/**
	* get last 15 search queries
	*/
	function lastResults($_addWhere = '') {
	
		global $LANG;
		
		if($this->id > 0) {
			$temp = 'tx_mhajaxsearch_query.nPid = '.$this->id;
			$addWhere = ('' != $_addWhere) ? ($_addWhere.' AND '.$temp) : $temp;
		}
		
		$query = 'SELECT tx_mhajaxsearch_query.sQuery AS sQuery, 
						tx_mhajaxsearch_query.nTstamp AS nTstamp,
						tx_mhajaxsearch_query.nResults AS nResults,
						fe_users.username AS uname, 
						pages.title AS sClicked
					FROM pages, tx_mhajaxsearch_query
					LEFT JOIN fe_users ON fe_users.uid = tx_mhajaxsearch_query.nUseId
					WHERE tx_mhajaxsearch_query.nClicked = pages.uid '.
					(isset($addWhere) ? 'AND '.$addWhere : '')
					.' ORDER BY nTstamp DESC
					LIMIT 15';
		$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
		
		$content = '<h2>'.$LANG->getLL('last').'</h2>';

		if($res) {
		
			if($GLOBALS['TYPO3_DB']->sql_num_rows($res) == 0) {
				$content .= $LANG->getLL('noresults');
				
			} else {
				$content .= '<table cellspacing="5" cellpadding="0" width="100%">';
				$content .= '<tr>';
				$content .= '<td><strong>'.$LANG->getLL('h_query').'</strong></td>';
				$content .= '<td><strong>'.$LANG->getLL('h_tstamp').'</strong></td>';
				$content .= '<td><strong>'.$LANG->getLL('h_user').'</strong></td>';
				$content .= '<td><strong>'.$LANG->getLL('h_results').'</strong></td>';
				$content .= '<td><strong>'.$LANG->getLL('h_clicked').'</strong></td>';
				$content .= '</tr>';

				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$content .= '<tr>';
					$content .= '<td>'.stripslashes($row['sQuery']).'</td>';
					$content .= '<td>'.date('Y-m-d H:i:s', $row['nTstamp']).'</td>';
					$content .= '<td>'.(($row['uname'] != '') ? $row['uname'] : '<i>'.$LANG->getLL('guest').'</i>').'</td>';
					$content .= '<td>'.$row['nResults'].'</td>';
					$content .= '<td>'.$row['sClicked'].'</td>';
					$content .= '</tr>';
				}

				$content .= '</table>';
			}
		} else {
			$content .= $LANG->getLL('error_database_select');
			$content .= '<br /><br />'.$query;
		}

		return $content;		
	}
	
	/**
	* get top 15 search queries
	*/
	function topResults($_addWhere = '') {
	
		global $LANG;
		
		if($this->id > 0) {
			$temp = 'tx_mhajaxsearch_query.nPid = '.$this->id;
			$addWhere = ('' != $_addWhere) ? ($_addWhere.' AND '.$temp) : $temp;
		}
		
		$query = 'SELECT tx_mhajaxsearch_query.sQuery AS sQuery,
						COUNT(tx_mhajaxsearch_query.sQuery) AS nAmount
					FROM pages, tx_mhajaxsearch_query
					WHERE tx_mhajaxsearch_query.nClicked = pages.uid '.
					(isset($addWhere) ? 'AND '.$addWhere : '')
					.' GROUP BY sQuery
					ORDER BY nAmount DESC
					LIMIT 15';
		$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
		
		$content = '<h2>'.$LANG->getLL('top').'</h2>';

		if($res) {
		
			if($GLOBALS['TYPO3_DB']->sql_num_rows($res) == 0) {
				$content .= $LANG->getLL('noresults');
				
			} else {
				$content .= '<table cellspacing="5" cellpadding="0" width="100%">';
				$content .= '<tr>';
				$content .= '<td><strong>'.$LANG->getLL('h_query').'</strong></td>';
				$helpimg = '<img src="'.$this->pathToImg.'helpbubble.gif" alt="'.$LANG->getLL('help_get').'" title="'.$LANG->getLL('help_get').'" />';
				$content .= '<td><strong>'.$LANG->getLL('h_amount').'</strong>&nbsp;<a href="javascript: alert(\''.$LANG->getLL('help_amount').'\');">'.$helpimg.'</a></td>';
				$content .= '</tr>';

				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$content .= '<tr>';
					$content .= '<td>'.stripslashes($row['sQuery']).'</td>';
					$content .= '<td>'.$row['nAmount'].'</td>';
					$content .= '</tr>';
				}

				$content .= '</table>';
			}
		} else {
			$content .= $LANG->getLL('error_database_select');
			$content .= '<br /><br />'.$query;
		}

		return $content;		
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mh_ajaxsearch/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mh_ajaxsearch/mod1/index.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_mhajaxsearch_module1');
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>
