<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Mario Haim <mario.haim@mediatool.at>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Ajax Searching Engine' for the 'mh_ajaxsearch' extension.
 *
 * @author	Mario Haim <mario.haim@mediatool.at>
 * @package	TYPO3
 * @subpackage	tx_mhajaxsearch
 */
class tx_mhajaxsearch_pi1 extends tslib_pibase {
	var $prefixId = 'tx_mhajaxsearch_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_mhajaxsearch_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'mh_ajaxsearch';	// The extension key.
	var $generalParams = array();	//array that contains all the general parameters to submit to the 'backend'
	var $templateFile = '';	//template source code
	var $pathToExt = 'typo3conf/ext/mh_ajaxsearch/';	//relative path to the extension
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string	$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		//$this->pi_loadLL();
		$GLOBALS['TSFE']->set_no_cache();
		$this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		
		if(!isset($GLOBALS['TSFE']->additionalHeaderData['tx_mhajaxsearch'])) $GLOBALS['TSFE']->additionalHeaderData['tx_mhajaxsearch'] = '';
	
		//initialize flexform if there is one otherwise fake it
		$this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
		
		if(isset($piFlexForm)) {
			foreach($piFlexForm['data'] as $sheet => $data) {
				foreach($data as $value) {
					foreach($value as $key => $val) {
						if(substr($key, 0, 16) == 'tx_mhajaxsearch_') {
							$temp = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
							if($temp != '') $flexform[substr($key, 16, strlen($key) - 16)] = $temp;
						}
					}
				}
			}
		} else {
			//fake it
			$flexform['nostyle'] = isset($this->conf['nostyle']) ? $this->conf['nostyle'] : 0;
			$flexform['spinner'] = isset($this->conf['nospinner']) ? $this->conf['nospinner'] : 0;
			$flexform['onload'] = isset($this->conf['onload']) ? $this->conf['onload'] : '';
			$flexform['startingpoint'] = $this->conf['startingpoint'];
			$flexform['recursive'] = $this->conf['recursive'];
			$flexform['tmpl'] = isset($this->conf['template']) ? $this->conf['template'] : '';
			$flexform['style'] = isset($this->conf['style']) ? $this->conf['style'] : '';
			$flexform['results'] = isset($this->conf['results']) ? $this->conf['results'] : -1;
			$flexform['search'] = isset($this->conf['search']) ? $this->conf['search'] : '';
			$flexform['logging'] = isset($this->conf['logging']) ? $this->conf['logging'] : '';
			$flexform['fwdSword'] = isset($this->conf['fwdsword']) ? $this->conf['fwdsword'] : '';
			$flexform['preview'] = isset($this->conf['preview']) ? $this->conf['preview'] : 0;
			$flexform['fwdSword'] = isset($this->conf['inclLang']) ? $this->conf['inclLang'] : 0;
			$flexform['alias'] = isset($this->conf['alias']) ? $this->conf['alias'] : '';
		}
		
		
		//logging enabled and search result clicked
		if($flexform['logging'] == 1 && isset($this->piVars['pid']) && isset($this->piVars['q'])) {
		
			//no sql injection please
			$this->piVars['pid'] = intval($this->piVars['pid']);
			
			//inserting the search string into the database
			$sql = 'INSERT INTO tx_mhajaxsearch_query(sQuery, nResults, nClicked, nTstamp, nUseId, nPid) VALUES("'.addslashes(str_replace('\'', '"', $this->piVars['q'])).'", '.intval($this->piVars['res']).', '.$this->piVars['pid'].', '.mktime().', '.(isset($GLOBALS['TSFE']->fe_user->user['uid']) ? $GLOBALS['TSFE']->fe_user->user['uid'] : '0').', '.$GLOBALS['TSFE']->id.')';
			@mysql_query($sql);
			
			//add search strings to the url if wanted
			if($flexform['fwdSword'] == 1) {
				$tmpswords = $_GET['sword_list'];
				for($i = 0; $i < count($tmpswords); $i++) $swords['sword_list['.$i.']'] = $tmpswords[$i];
				$swords['no_cache'] = 1;
			} else {
				$swords = array();
			}
			
			//redirect to wanted result page
			header('location: '.$this->pi_getPageLink($this->piVars['pid'], '', $swords));
			exit;
		}
		
		//alias forwarding
		if($flexform['alias'] != '') {
			$temp = explode(';', $flexform['alias']);
			$flexform['alias'] = '';
			foreach($temp as $tmpAr) {
				$tmpAr2 = explode('=', $tmpAr);
				$flexform['alias'] .= trim($tmpAr2[0]).'-'.trim($tmpAr2[1]).';';
			}
			$flexform['alias'] = substr($flexform['alias'], 0, strlen($flexform['alias']) - 1);
		}
		
		
		//preparation of the additional table searching string
		$flexform['search'] = preg_replace('/\r\n|\r|\n/', ' ', $flexform['search']); 
		
		//general parameters that have to be submitted each time a query is performed
		$this->generalParams = array(
			'pid'	=> $this->pi_getPidList($flexform['startingpoint'], $flexform['recursive']),
			'res'	=> $flexform['results'],
			'tab'	=> $flexform['search'],
			'pru'	=> $_SERVER['SERVER_NAME'].'/',
			'spi'	=> intval($flexform['spinner']),
			'log'	=> (isset($flexform['logging']) ? $flexform['logging'] : 0),
			'loc'	=> $GLOBALS['TSFE']->id,
			'fwd'	=> $flexform['fwdSword'],
			'lan'	=> (($flexform['inclLang'] == 1) ? $GLOBALS['TSFE']->sys_language_uid : -1),
			'pre'	=> (isset($flexform['preview']) ? $flexform['preview'] : 0),
			'ali'	=> $flexform['alias']
		);
		
		//load template file
		$defaultTmpl = 'res/tmpl/search.tmpl';
		$tmplFile = ($flexform['tmpl'] != '') 
						? ((strpos($flexform['tmpl'], '/') > 0) 
									? $flexform['tmpl']
									: 'uploads/tx_mhajaxsearch/'.$flexform['tmpl'])
						: $this->pathToExt.$defaultTmpl;
						
		$this->templateFile = file_exists($tmplFile)
									? $this->cObj->fileResource($tmplFile)
									: (file_exists($this->pathToExt.$defaultTmpl)
											? $this->cObj->fileResource($this->pathToExt.$defaultTmpl)
											: '');
		
		
		
		//define $onload which represents the setting of the curser on load
		if($flexform['onload'] != '') {
			$onload = 'function init() {
	document.getElementById(\''.(($flexform['onload'] == '') ? 'tx_mhajaxsearch_q' : $flexform['onload']).'\').focus();
}

window.onload = init;
';
		} else {
			$onload = '';
		}
		
		
		//output javascript variable definitions
		$GLOBALS['TSFE']->additionalHeaderData['tx_mhajaxsearch'] .= $this->createJsCode($this->generalParams, $onload);
		
		
		//include stylesheet if wanted
		if($flexform['nostyle'] != 1) {
			$defaultCss = 'res/style/tx_mhajaxsearch_style.css';
			
			$tmplCss = ($flexform['style'] != '') 
							? ((strpos($flexform['style'], '/') > 0) 
										? $flexform['style']
										: 'uploads/tx_mhajaxsearch/'.$flexform['style'])
							: $this->pathToExt.$defaultCss;
			
			$finalCss = file_exists($tmplCss)
							? $tmplCss
							: (file_exists($this->pathToExt.$defaultCss)
									? $this->pathToExt.$defaultCss
									: '');
			
			$GLOBALS['TSFE']->additionalHeaderData['tx_mhajaxsearch'] .= '
				<link href="'.$finalCss.'" rel="stylesheet" type="text/css" />';
		}
		
	
		//include javascript resources
		$GLOBALS['TSFE']->additionalHeaderData['tx_mhajaxsearch'] .= '
				<script src="'.$this->pathToExt.'res/js/tx_mhajaxsearch.js" type="text/javascript"></script>';
	
		//output the form
		return $this->pi_wrapInBaseClass($this->templateFile);
	}
	
	//convert a given array into javascript valid source code
	function createJsCode($_values, $_additional = '') {
		if(count($_values) <= 0) return '';
		
		$jsCode = '
<script type="text/javascript">
<!--
';
		foreach($_values as $varName => $varValue) {
			$jsCode .= 'var '.$varName.' = \''.$varValue.'\'; 
';
		}
		return $jsCode.$_additional.'//-->
</script>
';
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mh_ajaxsearch/pi1/class.tx_mhajaxsearch_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mh_ajaxsearch/pi1/class.tx_mhajaxsearch_pi1.php']);
}

?>
