<?php

//messages
$dberror	= 'Database error!';
$reserror	= 'No results found with search string: ';
$resamount	= 'results found with search string: ';


//php4 hack
// thanks to Gabriel Schreiber and Michael Glaesser
//function stripos is not available in php4
if(!function_exists('stripos')) {
	function stripos($_string, $_word) {
		$retval = false;
		for($i = 0; $i <= strlen($_string); $i++) {
			if(strtolower(substr($_string, $i, strlen($_word))) == strtolower($_word)) $retval = $i;
        }
		return $retval;
	}
}

//function str_ireplace is not available in php4
if(!function_exists('str_ireplace')) {
	function str_ireplace($_search, $_replace, $_subject) {
		$_search = preg_quote($_search, "/");
		return preg_replace("/".$_search."/i", $_replace, $_subject); 
	}
}

//database connection
require_once('../../../localconf.php');
mysql_connect($typo_db_host, $typo_db_username, $typo_db_password) or die($dberror);
mysql_select_db($typo_db) or die($dberror);

//preventative actions
$_GET['pid'] = stripslashes($_GET['pid']);
$_GET['res'] = intval($_GET['res']);
$_GET['log'] = intval($_GET['log']);
$_GET['fwd'] = intval($_GET['fwd']);
$_GET['lan'] = isset($_GET['lan']) ? intval($_GET['lan']) : -1;
$_GET['pre'] = intval($_GET['pre']);

//declarations
$select = $from = $where = $searchcols = $sstrings = $alias = array();

//main definitions
$ptable = 'pages';
$ppid = 'uid';
$ptitle = 'title';
$pdontshow = 'hidden';
$phidemenu = 'nav_hide';
$pnoindex = 'no_search';
$ptype = 'doktype';
$ltable = 'pages_language_overlay';
$lpid = 'pid';
$ltitle = 'title';
$llan = 'sys_language_uid';

//main selects and main searching columns
$select[] = $ptable.'.'.$ppid.' AS pid';
$select[] = $ptable.'.'.$ptitle.' AS title';
if($_GET['lan'] >= 0) $select[] = $ltable.'.'.$ltitle.' AS altLang';
$select[] = $ptable.'.'.$ptype.' AS type';

//main where parts (recursivity, hidden, hide_in_menu)
$wherefirst = $ptable.'.'.$ppid.' IN ('.$_GET['pid'].')';
$wherefirst .= ' AND '.$ptable.'.'.$pdontshow.' = 0';	//not hidden
$wherefirst .= ' AND '.$ptable.'.'.$phidemenu.' = 0';	//not hidden in menu
$wherefirst .= ' AND '.$ptable.'.'.$pnoindex.' = 0';	//not no_search

//flexform settings of additional table searches
if(strpos($_GET['tab'], ';') > 0) $tables = explode(';', $_GET['tab']);
elseif($_GET['tab'] == '') $tables = array();
else $tables[0] = $_GET['tab'];

if(count($tables) > 0) {
	foreach($tables as $table) {
		$params = explode(':', trim($table));
		if(count($params) == 3) {
			//table and pid column
			$fromCur = trim($params[0]);
			$from[] = array($fromCur, $ptable.'.'.$ppid.' = '.$fromCur.'.'.trim($params[2]));
			
			//columns
			if(strpos($params[1], ',') > 0) {
				$temp = explode(',', $params[1]);
				foreach($temp as $tempsing) {
					$searchcols[] = $fromCur.'.'.trim($tempsing);
				}
			} else {
				$fromCur.'.'.trim($params[1]);
			}
		}
	}
}

//add tt_content to the searching tables
$searchcols[] = 'tt_content.header';
$searchcols[] = 'tt_content.bodytext';

//comment the following line if your typo3 version is 3.8.1 or below
$searchcols[] = 'tt_content.altText';
//end commenting

$from[] = array('tt_content', $ptable.'.'.$ppid.' = tt_content.pid');
if($_GET['lan'] >= 0) $from[] = array($ltable, '('.$ptable.'.'.$ppid.' = '.$ltable.'.'.$lpid.' AND '.$ltable.'.'.$llan.' = '.$_GET['lan'].')');

//add page-title to searching tables
$searchcols[] = $ptable.'.'.$ptitle;

//add language overlay to searching tables if wanted
if($_GET['lan'] >= 0) $searchcols[] = $ltable.'.'.$ltitle;

//create alias array if wanted
$temp = explode(';', $_GET['ali']);
foreach($temp as $tmpAr) {
	$tmpAr2 = explode('-', $tmpAr);
	$tmpAr2[0] = intval($tmpAr2[0]);
	$tmpAr2[1] = intval($tmpAr2[1]);
	$alias[$tmpAr2[0]] = $tmpAr2[1];
}

//preparation of the searching word
$_GET['q'] = addslashes($_GET['q']);	//no sql injection please
$qumarks = substr_count($_GET['q'], '"');

if($qumarks >= 2) {
	$qstring = $_GET['q'];
	
	for($i = 1; $i <= $qumarks; $i++) {
	
		list($qrest, $qstring) = explode('\\"', trim($qstring), 2);
	
		$qrest = trim($qrest);
		if($i % 2 == 1) {
			if($qrest != '') $qs[] = array($qrest, '');
		} else {
			if($qrest != '') $qs[] = array($qrest, '"');
		}
	}
	
	$qstring = trim($qstring);
	if($qstring != '') $qs[] = array($qstring, '');
} else {
	$qs = array(array($_GET['q'], ''));
}

//searching the word
foreach($searchcols as $searchcol) {
	$qgroup = array();
	foreach($qs as $q) {
		if($q[1] == '"') $qgroup[] = $searchcol.' LIKE "%'.$q[0].'%" ';
		else $qgroup[] =  $searchcol.' LIKE "%'.preg_replace('/ +/', '%', $q[0]).'%" ';
	}
	$sstrings[] = '('.implode(' AND ', $qgroup).')';
}

//adding the search where's to the where array
$where[] = array('('.implode(' OR ', $sstrings).')', 'AND');

//adding the searched columns to the select array
$seltemp = implode('', $select);
for($i = 0; $i < count($searchcols); $i++) if(strpos($seltemp, $searchcols[$i]) === false) $select[] = $searchcols[$i].' AS s'.$i;

//build the statement
$sql = 	'SELECT ';
$sql .=	implode(', ', $select);
$sql .=	' FROM ';
$sql .=	$ptable;
foreach($from as $fromsing) $sql .= ' LEFT JOIN '.$fromsing[0].' ON '.$fromsing[1].' ';
$sql .=	' WHERE '.$wherefirst.' ';
foreach($where as $wheresing) $sql .= ' '.$wheresing[1].' '.$wheresing[0];
$sql .= ' GROUP BY '.$ptable.'.'.$ppid;
$sql .= ' ORDER BY '.$ptable.'.'.$ppid.' ASC';
$sql .=	($_GET['res'] > 0) ? (' LIMIT '.$_GET['res']) : '';

//execute the statement
$resultset = mysql_query($sql);
if(!$resultset) echo $dberror;
else {
	$resam = mysql_num_rows($resultset);
	$_GET['q'] = stripslashes($_GET['q']);
	
	//define special signs to convert
	$spSigns = array('', '', '', '', '', '', '', '', '?', '-', '', '', '');
	$spReplace = array('&auml;', '&ouml;', '&uuml;', '&Auml;', '&Ouml;', '&Uuml;', '&szlig;', '&sect;', '&#63;', '&#45;', '&#150;',
						'&quot;', '&quot;');
	
	if($resam <= 0) echo $reserror.'<strong>'.str_replace($spSigns, $spReplace, $_GET['q']).'</strong>';
	else {
	
		//create sword list if wanted (used for search words forwarding)
		$addString = '&no_cache=1';
		
		if($_GET['fwd'] == 1) {
			$more = 0;
			for($i = 0; $i < count($qs); $i++) {
				if($qs[$i][1] == '"') $addString .= '&sword_list['.($i+$more).']='.$qs[$i][0];
				else {
					$tmp = explode(' ', $qs[$i][0]);
					for($j = 0; $j < count($tmp); $j++) {
						$addString .= '&sword_list['.($i+$j+$more).']='.$tmp[$j];
						$tmpNr = $j;
					}
					$more += $tmpNr;
				}
			}
		}
		
	//echo $sql.'<br />';
	
		//output the list of results
		$echo = '';
		$minus = 0;
		while($row = mysql_fetch_array($resultset)) {
		
			//replace with alias if needed/wanted
			if($row['type'] == 254 && !isset($alias[$row['pid']])) {
				$minus++;
				continue;
			} elseif(isset($alias[$row['pid']])) {
				$row['pid'] = $alias[$row['pid']];
			}
		
			if($_GET['log'] == 1) {
				$link = 'index.php?id='.$_GET['loc'].'&tx_mhajaxsearch_pi1[pid]='.$row['pid'].'&tx_mhajaxsearch_pi1[res]='.$resam.'&tx_mhajaxsearch_pi1[q]='.str_replace('"', '\'', $_GET['q']).''.$addString;
			} else {
				$link = 'index.php?id='.$row['pid'].$addString;
			}
						
			$echo .= '<li><a href="'.$link.'">';
			
			//use either normal page title or language overlay one
			if($_GET['lan'] >= 0 && $row['altLang'] != '') $title = htmlentities($row['altLang']);
			else $title = htmlentities($row['title']);
			
			$echo .= $title;
			
			$echo .= '</a>';
			
			//output parts of text if wanted
			if($_GET['pre'] > 0) {
				if(!isset($cntRow)) $cntRow = count($row);
				$descText = '';
				
				for($i = 0; $i < $cntRow; $i++) {
					if(isset($row['s'.$i])) {
					
						if(isset($firstOcc)) unset($firstOcc);
					
						for($j = 0; $j < count($qs); $j++) {
							if($qs[$j][1] == '"') {
								$strpos = stripos($row['s'.$i], $qs[$j][0]);
								if($strpos === false) $descText = 'false';
								else if(!isset($firstOcc)) $firstOcc = $strpos;
							} else {
								$tmp = explode(' ', $qs[$j][0]);
								for($k = 0; $k < count($tmp); $k++) {
									$strpos = stripos($row['s'.$i], $tmp[$k]);
									if($strpos === false) $descText = 'false';
									else if(!isset($firstOcc)) $firstOcc = $strpos;
								}
							}
						}
						
						if($descText != 'false') {
							$row['s'.$i] = strip_tags($row['s'.$i]);
							$tmp = ($firstOcc >= $_GET['pre']) ? $firstOcc - $_GET['pre'] : 0;
							
							if($qs[0][1] == '"') $temp[0] = $qs[0][0];
							else $temp = explode(' ', $qs[0][0]);
							
							$lenQ = strlen($temp[0]);
							$descText = substr($row['s'.$i], $tmp, (2*$_GET['pre'] + $lenQ));
							
							$descText = str_ireplace($temp[0], '<strong>'.$temp[0].'</strong>', $descText);
							
							if(strlen($row['s'.$i]) > (2*$_GET['pre'] + $lenQ)) $descText .= ' ...';
							break;
						} else $descText = '';
						
					} else {
						$i = $cntRow + 2;
					}
				}
				
				if($descText == '') $echo .= '<br />&nbsp;';
				else $echo .= '<br />'.str_replace($spSigns, $spReplace, $descText).'<br />&nbsp;';
			}
			
			$echo .= '</li>';
		}
		echo ($resam - $minus).' '.$resamount.' <strong>'.str_replace($spSigns, $spReplace, $_GET['q']).'</strong><br /><br /><ul class="tx_mhajaxsearch_ul">';
		echo $echo.'</ul>';
	}
}

mysql_close();

?>
